<?php 
	if (!defined(JZ_SECURE_ACCESS)) die ('Security breach detected.');
	/**
	* - JINZORA | Web-based Media Streamer -  
	* 
	* Jinzora is a Web-based media streamer, primarily desgined to stream MP3s 
	* (but can be used for any media file that can stream from HTTP). 
	* Jinzora can be integrated into a CMS site, run as a standalone application, 
	* or integrated into any PHP website.  It is released under the GNU GPL.
	* 
	* - Resources -
	* - Jinzora Author: Ross Carlson <ross@jasbone.com>
	* - Web: http://www.jinzora.org
	* - Documentation: http://www.jinzora.org/docs	
	* - Support: http://www.jinzora.org/forum
	* - Downloads: http://www.jinzora.org/downloads
	* - License: GNU GPL <http://www.gnu.org/copyleft/gpl.html>
	* 
	* - Contributors -
	* Please see http://www.jinzora.org/team.html
	* 
	* - Code Purpose -
	* - Contains the Slick NG code
	*
	* @since 02.17.04 
	* @author Ross Carlson <ross@jinzora.org>
	* @author Ben Dodson <ben@jinzora.org>
	*/
	
	// Let's require the main classes for all the functions below
	require_once($include_path. 'frontend/class.php');
	require_once($include_path. 'frontend/blocks.php');	
	require_once($include_path. 'frontend/frontends/slickng/blocks.php');	
	
	
	class jzFrontend extends jzFrontendClass {
		function jzFrontend() {
			parent::_constructor();
		}
		
		function preheader ($title = false, $width = "100%", $align = "left", $js = true, $gzip = true, $cms_open = true) {
		  global $css, $cms_type, $site_title, $include_path, $root_dir, $node, $live_update, $gzip_handler, $jzSERVICES, $skin,$ajax_list,$jukebox,$my_frontend;

		  // Are they doing gzip compression?
		  if (($gzip_handler == "true" and $gzip == true) and $cms_type <> "mambo" and $cms_type <> "cpgnuke") {
		    //@ob_start('ob_gzhandler');
		  }
		  
		  $fe = new jzFrontend();
			$display = new jzDisplay();			
			
			// javascript
			if ($js) {
				$display->displayJavascript();
			}
			
			// AJAX:
			$ajax_list = array();
			if ($jukebox == "true") {
			  include_once($include_path."jukebox/ajax.php");
			  include_once($include_path."jukebox/ajax_scripts.php");
			}
			@include_once($include_path."frontend/frontends/${my_frontend}/ajax.php");
			@include_once($include_path."frontend/frontends/${my_frontend}/ajax_scripts.php");
			include_once($include_path."frontend/ajax.php");
			include_once($include_path."frontend/ajax_scripts.php");

			if (sizeof($ajax_list > 0)) { // This frontend has AJAX functions:
			  global $sajax_debug_mode, $sajax_export_list, $sajax_request_type, $sajax_remote_uri;
			  $sajax_debug_mode = 0;
			  include_once($include_path."lib/Sajax.php");
			  sajax_init();
			  for ($i = 0; $i < sizeof($ajax_list); $i++) {
			    sajax_export($ajax_list[$i]);
			  }
			  echo "\n<script>\n";
			  sajax_show_javascript();
			  echo "\n</script>\n";
			}
			//!! Stuff that requires database is safe beyond this point. !!//
			if ($live_update == "true" && !(isset($_GET['action']) && $_GET['action'] == "search")){
			  updateNodeCache($node);
			}
			if (!(isset($_GET['action']) && $_GET['action'] == "search")) {
				handlePageView($node);
			}
		}
			
		function leftNav() {
			global $root_dir, $skin, $jzUSER;
			
			// Now let's setup our blocks
			$blocks = new jzBlocks();
			$display = new jzDisplay();
			
			?>
			<link rel="stylesheet" href="/jinzora2/frontend/frontends/slickng/style.css" type="text/css" />
			<div id="slickNGLeftNav">
				<?php
					$arr = array();
					$arr['jz_path'] = "";
					echo '<a href="'. urlize($arr). '"><img src="'. $root_dir. '/style/'. $skin. '/big-logo.gif" border="0"></a>';
				?>
				<div id="slickNGLeftNavSpacer"></div>
				
				
				<div id="slickNGLeftNavBlock">
					<?php $blocks->usertools(); ?>
				</div>
				<div id="slickNGLeftNavSpacer"></div>
				
				
				<div id="slickNGLeftNavBlock">
					<h1>Now Streaming</h1>
					<?php $blocks->nowStreaming(); ?>
				</div>
				<div id="slickNGLeftNavSpacer"></div>
				
				<div id="slickNGLeftNavBlock">
					<h1>Who is Where</h1>
					<?php $blocks->userTracking(); ?>
				</div>
				<div id="slickNGLeftNavSpacer"></div>
				
				<?php
					if ($jzUSER->getSetting('powersearch')){
					?>
					<div id="slickNGLeftNavBlock">
						<?php 
							$url_search = array();
							$url_search['action'] = "powersearch";
						?>								
						<h1><?php echo '<a href="'. urlize($url_search). '">'. word("Search"). "</a>"; ?></h1>
						<?php $blocks->searchBlock(); ?>
					</div>
					<div id="slickNGLeftNavSpacer"></div>
					<?php
					}
				?>
				
				<?php
					if ($jzUSER->getSetting('stream')) {
						?>
						<div id="slickNGLeftNavBlock">
							<h1>Playlists</h1>
							<?php $blocks->playlists(); ?>
						</div>
						<div id="slickNGLeftNavSpacer"></div>
						<?php
					}
				?>
				
				
				<div id="slickNGLeftNavBlock">
					<h1>Browsing</h1>
					<?php $blocks->browsing(); ?>
				</div>
				<div id="slickNGLeftNavSpacer"></div>

			</div>
			<?php
		}
		
		function body() {
			global $root_dir, $skin;
			
			// Now let's setup our blocks
			$blocks = new jzBlocks();
			$display = new jzDisplay();
			
			?>
			<div id="slickNGBody">
				<div id="slickNGBlock">
					<h1>Header</h1>
					Block Content Goes Here
				</div>
			</div>
			<?php
		}

		function footer($node=false) {
			
		}
		
		function standardPage(&$node) {
			$this->preheader();
			$this->leftNav();
			$this->body();
		}
	}
?>






















